﻿using System;
using System.Linq;
using System.Collections.Generic;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Data;
using HeuristicLab.Encodings.PermutationEncoding;
using HeuristicLab.Optimization;
using HeuristicLab.Problems.Programmable;

namespace HeuristicLab.Problems.Programmable {
  public class CompiledSingleObjectiveProblemDefinition : CompiledProblemDefinition, ISingleObjectiveProblemDefinition {
    public bool Maximization { get { return false; } }

    public override void Initialize() {
      // Define the solution encoding which can also consist of multiple vectors, examples below
      //Encoding = new BinaryEncoding("b", length: 5);
      //Encoding = new IntegerEncoding("i", length: 5, min: 2, max: 14, step: 4);
      //Encoding = new RealEncoding("r", length: 5, min: -1.0, max: 1.0);
      //Encoding = new PermutationEncoding("p", length: 5, type: PermutationTypes.Absolute);

      //Encoding = new MultiEncoding()
      //.Add(new BinaryEncoding("b", length: 5))
      //.Add(new IntegerEncoding("i", length: 5, min: 2, max: 14, step: 4))
      //.Add(new RealEncoding("r", length: 5, min: -1.0, max: 1.0))
      //.Add(new PermutationEncoding("p", length: 5, type: PermutationTypes.Absolute))
      //;
    }

    public double Evaluate(Individual individual, IRandom random) {
      var quality = 0.0;
      // use vars.yourVariable to access variables in the variable store i.e. yourVariable
      //quality = individual.RealVector("r").Sum(x => x * x);
      return quality;
    }

    public void Analyze(Individual[] individuals, double[] qualities, ResultCollection results) {
      // write or update results given the range of vectors and resulting qualities
      // use e.g. vars.yourVariable to access variables in the variable store i.e. yourVariable
    }

    public IEnumerable<Individual> GetNeighbors(Individual individual, IRandom random) {
      // Create new vectors, based on the given one that represent small changes
      // This method is only called from move-based algorithms (LocalSearch, SimulatedAnnealing, etc.)
      while (true) {
        // this is not an infinite loop as only a finite amount of samples will be drawn
        // it is possible to return a concrete amount of neighbors also
        var neighbor = individual.Copy();
        //e.g. make a bit flip in a binary parameter
        //var bIndex = random.Next(neighbor.BinaryVector("b").Length);
        //neighbor.BinaryVector("b")[bIndex] = !neighbor.BinaryVector("b")[bIndex];
        yield return neighbor;
      }
    }

    // implement further classes and methods
  }
}

